use num_derive::FromPrimitive;

#[derive(Debug, FromPrimitive)]
pub enum ReadStatError {
    READSTAT_OK = 0 as isize,
    READSTAT_ERROR_OPEN = 1 as isize,
    READSTAT_ERROR_READ = 2 as isize,
    READSTAT_ERROR_MALLOC = 3 as isize,
    READSTAT_ERROR_USER_ABORT = 4 as isize,
    READSTAT_ERROR_PARSE = 5 as isize,
    READSTAT_ERROR_UNSUPPORTED_COMPRESSION = 6 as isize,
    READSTAT_ERROR_UNSUPPORTED_CHARSET = 7 as isize,
    READSTAT_ERROR_COLUMN_COUNT_MISMATCH = 8 as isize,
    READSTAT_ERROR_ROW_COUNT_MISMATCH = 9 as isize,
    READSTAT_ERROR_ROW_WIDTH_MISMATCH = 10 as isize,
    READSTAT_ERROR_BAD_FORMAT_STRING = 11 as isize,
    READSTAT_ERROR_VALUE_TYPE_MISMATCH = 12 as isize,
    READSTAT_ERROR_WRITE = 13 as isize,
    READSTAT_ERROR_WRITER_NOT_INITIALIZED = 14 as isize,
    READSTAT_ERROR_SEEK = 15 as isize,
    READSTAT_ERROR_CONVERT = 16 as isize,
    READSTAT_ERROR_CONVERT_BAD_STRING = 17 as isize,
    READSTAT_ERROR_CONVERT_SHORT_STRING = 18 as isize,
    READSTAT_ERROR_CONVERT_LONG_STRING = 19 as isize,
    READSTAT_ERROR_NUMERIC_VALUE_IS_OUT_OF_RANGE = 20 as isize,
    READSTAT_ERROR_TAGGED_VALUE_IS_OUT_OF_RANGE = 21 as isize,
    READSTAT_ERROR_STRING_VALUE_IS_TOO_LONG = 22 as isize,
    READSTAT_ERROR_TAGGED_VALUES_NOT_SUPPORTED = 23 as isize,
    READSTAT_ERROR_UNSUPPORTED_FILE_FORMAT_VERSION = 24 as isize,
    READSTAT_ERROR_NAME_BEGINS_WITH_ILLEGAL_CHARACTER = 25 as isize,
    READSTAT_ERROR_NAME_CONTAINS_ILLEGAL_CHARACTER = 26 as isize,
    READSTAT_ERROR_NAME_IS_RESERVED_WORD = 27 as isize,
    READSTAT_ERROR_NAME_IS_TOO_LONG = 28 as isize,
    READSTAT_ERROR_BAD_TIMESTAMP_STRING = 29 as isize,
    READSTAT_ERROR_BAD_FREQUENCY_WEIGHT = 30 as isize,
    READSTAT_ERROR_TOO_MANY_MISSING_VALUE_DEFINITIONS = 31 as isize,
    READSTAT_ERROR_NOTE_IS_TOO_LONG = 32 as isize,
    READSTAT_ERROR_STRING_REFS_NOT_SUPPORTED = 33 as isize,
    READSTAT_ERROR_STRING_REF_IS_REQUIRED = 34 as isize,
    READSTAT_ERROR_ROW_IS_TOO_WIDE_FOR_PAGE = 35 as isize,
    READSTAT_ERROR_TOO_FEW_COLUMNS = 36 as isize,
    READSTAT_ERROR_TOO_MANY_COLUMNS = 37 as isize,
    READSTAT_ERROR_NAME_IS_ZERO_LENGTH = 38 as isize,
    READSTAT_ERROR_BAD_TIMESTAMP_VALUE = 39 as isize,
}